package com.four.Instantmessaging.controller;

import com.alibaba.fastjson.JSONObject;
import com.four.Instantmessaging.service.InstantService;
import com.four.common.duck.Result;
import com.four.common.duck.request.UserRequest;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;

@RestController
@RequestMapping("/instant")
@Log4j2
public class InstantController {

    @Autowired
    private InstantService instantService;
    @Autowired
    private HttpServletRequest request;

    /**
     * 添加IM用户
     * @param userRequest
     * @return
     */
    @PostMapping("/insertUser")
    public Result insertUser(@RequestBody UserRequest userRequest){
        log.info("功能名称：添加IM用户,请求URI:{},请求方法:{},请求参数:{}",request.getRequestURI(),
                request.getMethod(), JSONObject.toJSONString(userRequest));
        Boolean b=instantService.insertUser(userRequest);
        log.info("功能名称：添加IM用户,请求URI:{},请求方法:{},返回结果:{}",request.getRequestURI(),
                request.getMethod(), JSONObject.toJSONString(b));
        return Result.success(b,"注册成功");
    }

    /**
     * 删除IM用户
     * @param username
     * @return
     */
    @PostMapping("/delUser")
    public Result delUser(@RequestParam String username){
        log.info("功能名称:删除IM用户,请求URI:{},请求方法:{},请求参数:{}",request.getRequestURI(),
                request.getMethod(),JSONObject.toJSONString(username));
        Boolean b=instantService.delUser(username);
        log.info("功能名称:删除IM用户,请求URI:{},请求方法:{},返回结果:{}",request.getRequestURI(),
                request.getMethod(),JSONObject.toJSONString(b));
        return Result.success(b,"注销成功");
    }

    /**
     * 添加IM好友
     * @param userRequest
     * @return
     */
    @PostMapping("/insertFriend")
    public Result insertFriend(@RequestBody UserRequest userRequest){
        log.info("功能名称:添加IM好友,请求URI:{},请求方法:{},请求参数:{}",request.getRequestURI(),
                request.getMethod(),JSONObject.toJSONString(userRequest));
        Boolean b=instantService.insertFriend(userRequest);
        log.info("功能名称:添加IM好友,请求URI:{},请求方法:{},返回结果:{}",request.getRequestURI(),
                request.getMethod(),JSONObject.toJSONString(userRequest));
        return Result.success(b,"添加成功");
    }


    /**
     * 删除好友
     * @param userRequest
     * @return
     */
    @PostMapping("/delFriend")
    public Result deleteFriend(@RequestBody UserRequest userRequest){
        log.info("功能名称:删除好友,请求URI:{},请求方法:{},请求参数:{}",request.getRequestURI(),
                request.getMethod(),JSONObject.toJSONString(userRequest));
        Boolean b=instantService.deleteFriend(userRequest);
        log.info("功能名称:删除好友,请求URI:{},请求方法:{},返回结果:{}",request.getRequestURI(),
                request.getMethod(),JSONObject.toJSONString(b));
        return Result.success(b,"删除成功");
    }

    /**
     * IM发送消息
     * @param userRequest
     * @return
     */
    @PostMapping("/sendMsg")
    public Result sendMsg(@RequestBody UserRequest userRequest){
        log.info("功能名称:IM发送消息,请求URI:{},请求方法:{},请求参数:{}",request.getRequestURI(),
                request.getMethod(),JSONObject.toJSONString(userRequest));
        Boolean b=instantService.sendMsg(userRequest);
        log.info("功能名称:IM发送消息,请求URI:{},请求方法:{},返回结果:{}",request.getRequestURI(),
                request.getMethod(),JSONObject.toJSONString(b));
        return Result.success(b,"发送成功");
    }



}
