package com.four.doctor.controller;

import com.alibaba.fastjson.JSONObject;
import com.four.common.duck.Result;
import com.four.common.duck.domain.GiftRecord;
import com.four.doctor.service.GiftRecordDoctorService;
import lombok.extern.log4j.Log4j2;
import org.apache.catalina.LifecycleState;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

@RestController
@RequestMapping("/giftRecordDoctor")
@Log4j2
public class GiftRecordDoctorController {

    @Autowired
    private GiftRecordDoctorService giftRecordDoctorService;
    @Autowired
    private HttpServletRequest request;

    /**
     * 查看患者送给自己的礼物
     * @param registrationInformationId
     * @return
     */
    @PostMapping("/ShowGiftRecordDoctor")
    public Result<List<GiftRecord>> ShowGiftRecordDoctor(@RequestParam Long registrationInformationId){
        log.info("功能名称:查看患者送给自己的礼物,请求URI:{},请求方法:{},请求参数:{}",request.getRequestURI(),
                request.getMethod(), JSONObject.toJSONString(registrationInformationId));
        List<GiftRecord> list=giftRecordDoctorService.ShowGiftRecordDoctor(registrationInformationId);
        log.info("功能名称:查看患者送给自己的礼物,请求URI:{},请求方法:{},返回结果:{}",request.getRequestURI(),
                request.getMethod(),JSONObject.toJSONString(list));
        return Result.success(list);

    }
}
