package com.four.doctor.controller;

import com.alibaba.fastjson.JSONObject;
import com.four.common.core.domain.Result;
import com.four.common.duck.interrogation.HistoricalConsultation;
import com.four.doctor.service.HistoricalDoctorService;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

@RestController
@RequestMapping("/historicalDoctor")
@Log4j2
public class HistoricalDoctorController {

    @Autowired
    private HistoricalDoctorService historicalDoctorService;
    @Autowired
    private HttpServletRequest request;

    /**
     *医生查询自己的历史问诊
     * @param registrationInformationId
     * @return
     */
    @PostMapping("/ShowHistoricalDoctor")
    public Result<List<HistoricalConsultation>> ShowHistoricalDoctor(@RequestParam Long registrationInformationId){
        log.info("功能名称:医生查询历史问诊,请求URI:{},请求方法:{},请求参数:{}",request.getRequestURI(),
                request.getMethod(), JSONObject.toJSONString(registrationInformationId));
        List<HistoricalConsultation> list= historicalDoctorService.ShowHistoricalDoctor(registrationInformationId);
        log.info("功能名称:元素查询历史问诊,请求URI:{},请求方法:{}，返回结果:{}",request.getRequestURI(),
                request.getMethod(),JSONObject.toJSONString(list));
        return Result.success(list);
    }
}
