package com.four.doctor.controller;

import com.alibaba.fastjson.JSONObject;
import com.four.common.core.domain.Result;
import com.four.common.duck.interrogation.PatientEvaluator;
import com.four.doctor.service.PatientDoctorService;
import lombok.experimental.PackagePrivate;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

@RestController
@RequestMapping("/patientDoctor")
@Log4j2
public class PatientDoctorController {

    @Autowired
    private PatientDoctorService patientDoctorService;
    @Autowired
    private HttpServletRequest request;

    /**
     * 医生查看患者对自己评价
     * @param registrationInformationId
     * @return
     */
    @PostMapping("/ShowPatientEvaluatorDoctor")
    public Result<List<PatientEvaluator>> ShowPatientEvaluatorDoctor(@RequestParam Long registrationInformationId){
        log.info("功能名称:医生查看患者对自己评价,请求URI:{},请求方法:{},请求参数:{}",request.getRequestURI(),
                request.getMethod(), JSONObject.toJSONString(registrationInformationId));
        List<PatientEvaluator> list=patientDoctorService.ShowPatientEvaluatorDoctor(registrationInformationId);
        log.info("功能名称:医生查看患者对自己的评价,请求URI:{},请求方法:{},返回结果:{}",request.getRequestURI(),
                request.getMethod(),JSONObject.toJSONString(list));
        return Result.success(list);
    }

}
