package com.four.patient.controller;

import com.alibaba.fastjson.JSONObject;
import com.four.common.core.domain.Result;
import com.four.common.duck.interrogation.FollowDoctor;
import com.four.patient.service.FollowDoctorService;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

@RestController
@RequestMapping("/followDoctor")
@Log4j2
public class FollowDoctorController {

    @Autowired
    private FollowDoctorService followDoctorService;
    @Autowired
    private HttpServletRequest request;

    /**
     * 点击关注添加医生到我的关注
     * @param followDoctor
     * @return
     */
    @PostMapping("/insertFollowDoctor")
    public Result insertFollowDoctor(@RequestBody FollowDoctor followDoctor){
        log.info("功能名称:关注医生,请求URI:{},请求方法:{},请求参数:{}",request.getRequestURI(),
                request.getMethod(), JSONObject.toJSONString(followDoctor));
        Integer i=followDoctorService.insertFollowDoctor(followDoctor);
        log.info("功能名称:关注医生,请求URI:{},请求方法:{},返回结果:{}",request.getRequestURI(),
                request.getMethod(), JSONObject.toJSONString(i));
        return Result.success(i,"关注成功");
    }

    /**
     * 二次点击取消关注
     * @param registrationInformationId
     * @return
     */
    @PostMapping("/delFollowDoctor")
    public Result delFollowDoctor(@RequestParam Integer registrationInformationId){
        log.info("功能名称:取消关注,请求URI:{},请求方法:{},请求参数:{}",request.getRequestURI(),
                request.getMethod(),JSONObject.toJSONString(registrationInformationId));
        Integer i=followDoctorService.delFollowDoctor(registrationInformationId);
        log.info("功能名称:取消关注,请求URI:{},请求方法:{}，返回结果:{}",request.getRequestURI(),
                request.getMethod(),JSONObject.toJSONString(i));
        return Result.success(i,"取消关注");
    }

//    @PostMapping("/delFollowDoctor")
//    public Result delFollowDocter(@RequestParam Integer registrationInformationId)
//    {
//        log.info("功能名称:取消关注，请求URI:{},请求方式:{},请求参数:{}",request.getRequestURI(),
//                request.getMethod(),JSONObject.toJSONString(registrationInformationId));
//        Integer i = followDoctorService.delFollowDoctor(registrationInformationId);
//        log.info("功能名称:取消关注,请求URI,{},请求方法:{},返回结果:{}",request.getRequestURI(),
//                request.getMethod(),JSONObject.toJSONString(i));
//        return Result.success(i,"取消关注");
//    }
    /***
     * 我的关注
     * @return
     */
    @GetMapping("/ShowFollowDoctor")
    public Result<List<FollowDoctor>> ShowFollowDoctor(){
        log.info("功能名称:查询我的关注，请求URI:{},请求方法:{}",request.getRequestURI(),
                request.getMethod());
        List<FollowDoctor> followDoctorList=followDoctorService.ShowFollowDoctor();
        log.info("功能名称:查询我的关注，请求URI:{},请求方法：{},返回结果:{}",request.getRequestURI(),
                request.getMethod(),JSONObject.toJSONString(followDoctorList));
        return Result.success(followDoctorList);
    }

}
