package com.four.patient.controller;

import com.alibaba.fastjson.JSONObject;
import com.four.common.core.domain.Result;
import com.four.common.duck.domain.GiftRecord;
import com.four.common.duck.gift.Gift;
import com.four.patient.service.GiftService;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

@RestController
@RequestMapping("/gift")
@Log4j2
public class GiftController {

    @Autowired
    private GiftService giftService;
    @Autowired
    private HttpServletRequest request;

    /**
     * 查询礼物列表
     * @return
     */
    @GetMapping("/ShowGiftAll")
    public Result<List<Gift>> ShowGiftAll(){
        log.info("功能名称:查询礼物表,请求URI:{}，请求方法:{}",request.getRequestURI(),
                request.getMethod());
        List<Gift> list=giftService.ShowGiftAll();
        log.info("功能名称:查询礼物表,请求URI:{}，请求方法:{},返回结果:{}",request.getRequestURI(),
                request.getMethod(), JSONObject.toJSONString(list));
        return Result.success(list);
    }

    /**
     * 生成礼物记录并患者付出礼物相应价值金额
     * 医生接收金额
     * @param giftRecord
     * @return
     */
    @PostMapping("/insertGiftLog")
    public Result insertGiftLog(@RequestBody GiftRecord giftRecord){
        log.info("功能名称:添加礼物记录，请求URI:{},请求方法:{},请求参数:{}",request.getRequestURI(),
                request.getMethod(),JSONObject.toJSONString(giftRecord));
        Integer i=giftService.insertGiftLog(giftRecord);
        log.info("功能名称:添加礼物记录,请求URI:{},请求方法:{},返回结果:{}",request.getRequestURI(),
                request.getMethod(),JSONObject.toJSONString(i));
        return Result.success(i,"添加成功");
    }

}
