package com.four.patient.controller;

import com.alibaba.fastjson.JSONObject;
import com.four.common.duck.Result;
import com.four.common.duck.interrogation.HistoricalConsultation;
import com.four.patient.service.HistoricalConsultationService;
import lombok.extern.java.Log;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

@RestController
@RequestMapping("/historicalPatient")
@Log4j2
public class HistoricalConsultationController {

    @Autowired
    private HistoricalConsultationService historicalConsultationService;

    @Autowired
    private HttpServletRequest request;

    /**
     * 结束问诊时添加问诊记录并付问诊金额
     * @param historicalConsultation
     * @return
     */
    @PostMapping("/insertHistoricalConsultation")
    public Result insertHistoricalConsultation(@RequestBody HistoricalConsultation historicalConsultation){
        log.info("功能名称:结束问诊后生成历史记录并结算诊金,请求URI:{},请求方法:{},请求参数:{}",request.getRequestURI(),
                request.getMethod(), JSONObject.toJSONString(historicalConsultation));
        Integer i=historicalConsultationService.insertHistoricalConsultation(historicalConsultation);
        log.info("功能名称:结束问诊后生成历史记录并结算诊金,请求URI:{},请求方法:{},返回结果:{}",request.getRequestURI(),
                request.getMethod(),JSONObject.toJSONString(i));
        return Result.success(i,"历史记录添加成功");
    }

    /**
     * 查询历史问诊记录
     * @return
     */
    @GetMapping("/ShowHistoricalConsultation")
    public Result<List<HistoricalConsultation>> ShowHistoricalConsultation(){
        log.info("功能名称:查询历史问诊记录,请求URI:{},请求方法:{}",request.getRequestURI(),
                request.getMethod());
        List<HistoricalConsultation> list=historicalConsultationService.ShowHistoricalConsultation();
        log.info("功能名称:查询历史问诊记录,请求URI:{},请求方法:{},返回结果:{}",request.getRequestURI(),
                request.getMethod(),JSONObject.toJSONString(list));
        return Result.success(list);
    }

    @PostMapping("/updateHistorical")
    public Result updateHistorical(@RequestParam Long HistoricalConsultationId){
        log.info("功能名称:结束问诊,请求URI:{},请求方法:{},请求参数:{}",request.getRequestURI(),
                request.getMethod(),JSONObject.toJSONString(historicalConsultationService));
        Integer i =historicalConsultationService.updateHisorical(HistoricalConsultationId);
        log.info("功能名称:结束问诊,请求URI:{},请求方法:{},请求参数:{}",request.getRequestURI(),
                request.getMethod(),JSONObject.toJSONString(i));
        return Result.success(i,"结束问诊成功");
    }
}
