package com.four.patient.controller;

import com.alibaba.fastjson.JSONObject;
import com.four.common.core.domain.Result;
import com.four.common.duck.interrogation.PatientEvaluator;
import com.four.patient.service.PatientEvaluatorService;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import javax.servlet.http.HttpServletRequest;
import java.util.List;

@RestController
@RequestMapping("/patientEvaluator")
@Log4j2
public class PatientEvaluatorController {

    @Autowired
    private PatientEvaluatorService patientEvaluatorService;
    @Autowired
    private HttpServletRequest request;

    /**
     * 查询患者评价表
     * @return
     */
    @GetMapping("/ShowPatientEvaluatorAll")
    public Result<List<PatientEvaluator>> ShowPatientEvaluatorAll(){
        log.info("功能名称:查询患者对医生的评价，请求URI:{},请求方法:{}",request.getRequestURI(),
                request.getMethod());
        List<PatientEvaluator> list=patientEvaluatorService.ShowPatientEvaluatorAll();
        log.info("功能名称:查询患者对医生评价,请求URI:{}，请求方法:{}，返回结果:{}",request.getRequestURI(),
                request.getMethod(), JSONObject.toJSONString(list));
        return Result.success(list);
    }

    /**
     * 患者对医生进行评价
     * @param patientEvaluator
     * @return
     */
    @PostMapping("/insertPatientEvaluator")
    public Result insertPatientEvaluator(@RequestBody PatientEvaluator patientEvaluator){
        log.info("功能名称:患者评论医生,请求URI:{},请求方法:{}，请求参数:{}",request.getRequestURI(),
                request.getMethod(),JSONObject.toJSONString(patientEvaluator));
        Integer i=patientEvaluatorService.insertPatientEvaluator(patientEvaluator);
        log.info("功能名称:患者评论医生,请求URI:{},请求方法:{}，返回结果:{}",request.getRequestURI(),
                request.getMethod(),JSONObject.toJSONString(i));
        return Result.success(i,"评价成功");
    }
}
