package com.four.patient.feign;

import com.four.common.core.web.domain.AjaxResult;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;

@FeignClient("four-system")
public interface DoctorNumberFeign {
    /**
     * 查询好评人数倒序的医生信息
     * @param medicalDepartmentId;
     * @author 李闯
     * @return
     */
    @PostMapping("/user/findDoctorNumber/{medicalDepartmentId}")
    public AjaxResult findDoctorNumber(@PathVariable Long medicalDepartmentId);
}
