package com.four.patient.service.Impl;

import com.four.common.duck.interrogation.FollowDoctor;
import com.four.common.security.utils.SecurityUtils;
import com.four.patient.mapper.FollowDoctorMapper;
import com.four.patient.service.FollowDoctorService;
import com.four.system.api.model.LoginUser;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
public class FollowDoctorServiceImpl implements FollowDoctorService {

    @Autowired
    private FollowDoctorMapper followDoctorMapper;

    @Transactional
    @Override
    public Integer insertFollowDoctor(FollowDoctor followDoctor) {
        Integer i=followDoctorMapper.insertFollowDoctor(followDoctor);
        if (i<0){
            return null;
        }
        LoginUser loginUser = SecurityUtils.getLoginUser();
        Long userid = loginUser.getUserid();
        followDoctor.setUserId(userid);
        return i;
    }
    @Transactional
    @Override
    public Integer delFollowDoctor(Integer registrationInformationId) {
        Integer i=followDoctorMapper.delFollowDoctor(registrationInformationId);
        if (i<0){
            return null;
        }
        return i;
    }

    @Override
    public List<FollowDoctor> ShowFollowDoctor() {
        List<FollowDoctor> followDoctorList=followDoctorMapper.ShowFollowDoctor();
        return followDoctorList;
    }
}
