package com.four.patient.service.Impl;

import com.four.common.duck.domain.GiftRecord;
import com.four.common.duck.gift.Gift;
import com.four.common.duck.interrogation.RegistrationInformation;
import com.four.common.duck.my.User;
import com.four.common.security.utils.SecurityUtils;
import com.four.patient.mapper.GiftMapper;
import com.four.patient.service.GiftService;
import com.four.system.api.model.LoginUser;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

@Service
public class GiftServiceImpl implements GiftService {

    @Autowired
    private GiftMapper giftMapper;

    @Override
    public List<Gift> ShowGiftAll() {
        List<Gift> gifts=giftMapper.ShowGiftAll();
        return gifts;
    }
    @Transactional
    @Override
    public Integer insertGiftLog(GiftRecord giftRecord) {
        Integer i=giftMapper.insertGiftLog(giftRecord);
        if (i<0){
            return null;
        }
        LoginUser loginUser = SecurityUtils.getLoginUser();
        //获取患者id
        Long userid = loginUser.getUserid();
        giftRecord.setGiverId(userid);
        giftRecord.setGiftGivingTime(new Date());
        //获取患者余额
        double userMoney = loginUser.getSysUser().getUserMoney().doubleValue();
        Gift gift=giftMapper.findByGiftId(giftRecord.getGiftId());
        //获取礼物价格
        double giftPrice = gift.getGiftPrice().doubleValue();
        double patientMoney=(userMoney-giftPrice);
        giftMapper.updPatientMoney(patientMoney,userid);
        //获取医生用户信息
        RegistrationInformation registrationInformation =giftMapper.findByRegistration(giftRecord.getRegistrationInformationId());
        //获取医生用户
        User user=giftMapper.findByUserId(registrationInformation.getUserId());
        double doctorMoney = (user.getUserMoney().doubleValue() + giftPrice);
        giftMapper.updDoctorMoney(doctorMoney,user.getUserId());
        return i;
    }
}
