package com.four.patient.service.Impl;

import com.four.common.duck.interrogation.HistoricalConsultation;
import com.four.common.duck.interrogation.RegistrationInformation;
import com.four.common.duck.my.User;
import com.four.common.security.utils.SecurityUtils;
import com.four.patient.mapper.GiftMapper;
import com.four.patient.mapper.HistoricalConsultationMapper;
import com.four.patient.service.HistoricalConsultationService;
import com.four.system.api.model.LoginUser;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigDecimal;
import java.util.List;

@Service
public class HistoricalConsultationServiceImpl implements HistoricalConsultationService{

    @Autowired
    private HistoricalConsultationMapper historicalConsultationMapper;

    @Autowired
    private GiftMapper giftMapper;

    @Transactional
    @Override
    public Integer insertHistoricalConsultation(HistoricalConsultation historicalConsultation) {
        Integer i=historicalConsultationMapper.insertHistoricalConsultation(historicalConsultation);
        if (i<0){
            return null;
        }
        //获取患者id
        LoginUser loginUser = SecurityUtils.getLoginUser();
        historicalConsultation.setPatientId(loginUser.getUserid());
        historicalConsultation.setHistoricalConsultationStatus(2);
        //获取患者金额
        Double userMoney= loginUser.getSysUser().getUserMoney().doubleValue();
        //获取医生信息
        RegistrationInformation registration = giftMapper.findByRegistration(historicalConsultation.getRegistrationInformationId());
        //获取医生诊金
        double consultPrice = registration.getConsultingPrice().doubleValue();
        //获取用户结清诊金后余额
        double patientMoney=(userMoney-consultPrice);
        giftMapper.updPatientMoney(patientMoney,loginUser.getUserid());
        //获取医生的用户信息
        User user = giftMapper.findByUserId(registration.getUserId());
        //医生问诊后的余额
        Double doctorPrice=(user.getUserMoney().doubleValue() + consultPrice);
        giftMapper.updDoctorMoney(doctorPrice,user.getUserId());
        return i;
    }

    @Override
    public List<HistoricalConsultation> ShowHistoricalConsultation() {
        List<HistoricalConsultation> historicalConsultationList=historicalConsultationMapper.ShowHistoricalConsultation();
        return historicalConsultationList;
    }

    @Override
    public Integer updateHisorical(Long historicalConsultationId) {
        Integer i=historicalConsultationMapper.updateHisorical(historicalConsultationId);
        if (i<0){
            return null;
        }
        return i;
    }
}
