package com.four.patient.service.Impl;

import com.four.common.duck.interrogation.PatientEvaluator;
import com.four.common.security.utils.SecurityUtils;
import com.four.patient.mapper.PatientEvaluatorMapper;
import com.four.patient.service.PatientEvaluatorService;
import com.four.system.api.model.LoginUser;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;
import java.util.List;

@Service
public class PatientEvaluatorServiceImpl implements PatientEvaluatorService {

    @Autowired
    private PatientEvaluatorMapper patientEvaluatorMapper;

    @Override
    public List<PatientEvaluator> ShowPatientEvaluatorAll() {
        List<PatientEvaluator> patientEvaluatorList=patientEvaluatorMapper.ShowPatientEvaluatorAll();
        return patientEvaluatorList;
    }
    @Transactional
    @Override
    public Integer insertPatientEvaluator(PatientEvaluator patientEvaluator) {
        Integer i=patientEvaluatorMapper.insertPatientEvaluator(patientEvaluator);
        if (i<0){
            return null;
        }
        LoginUser loginUser = SecurityUtils.getLoginUser();
        Long userid = loginUser.getUserid();
        patientEvaluator.setPatientId(userid);
        patientEvaluator.setCommentTime(new Date());
        return i;
    }
}
