package com.four.patient.service.Impl;

import com.four.common.duck.Result;
import com.four.common.duck.communitypatients.SymptomsDrugs;
import com.four.common.duck.response.ResponseRegistrationInformation;
import com.four.patient.feign.SymptomsDrugsFeign;
import com.four.patient.mapper.RegistrationInformationMapper;
import com.four.patient.service.RegistrationInformationService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class RegistrationInformationServiceImpl implements RegistrationInformationService {

    @Autowired
    private RegistrationInformationMapper registrationInformationMapper;

    @Autowired
    private SymptomsDrugsFeign symptomsDrugsFeign;




    @Override
    public List<ResponseRegistrationInformation> ShowRegistrationInformationAllPrice(Long medicalDepartmentId) {
        List<ResponseRegistrationInformation> list = registrationInformationMapper.ShowRegistrationInformationAllPrice(medicalDepartmentId);
        return list;
    }

    @Override
    public List<ResponseRegistrationInformation> ShowRegistrationInformationNumber(Long medicalDepartmentId) {
        List<ResponseRegistrationInformation> list = registrationInformationMapper.ShowRegistrationInformationNumber(medicalDepartmentId);
        return list;
    }

    @Override
    public List<ResponseRegistrationInformation> ShowRegistrationInformationPraise(Long medicalDepartmentId) {
        List<ResponseRegistrationInformation> list = registrationInformationMapper.ShowRegistrationInformationPraise(medicalDepartmentId);
        return list;
    }

    @Override
    public List<ResponseRegistrationInformation> ShowRegistrationInformationAll(Long medicalDepartmentId) {
        List<ResponseRegistrationInformation> list=registrationInformationMapper.ShowRegistrationInformationAll(medicalDepartmentId);
        return list;
    }

    @Override
    public List<SymptomsDrugs> ShowSymptomsDrug() {
        Result<List<SymptomsDrugs>> symptomDrugsAll = symptomsDrugsFeign.findSymptomDrugsAll();
        List<SymptomsDrugs> symptomsDrugsList = symptomDrugsAll.getData();
        return symptomsDrugsList;
    }

    @Override
    public List<ResponseRegistrationInformation> ShowRegistration(Long registrationInformationId) {
        List<ResponseRegistrationInformation> informationList=registrationInformationMapper.ShowRegistration(registrationInformationId);
        return informationList;
    }


}
